
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class Options extends JFrame implements Runnable{

//	private int initialVelocity;
//	private int horDirection;

	
	private JPanel panel;
	private JTextField horDirectionInput;
	private JTextField initialVelocityInput;
	private JTextField fileInput;
	private JTextField stepInput;
	private JTextField ranInput1;
	private JTextField ranInput2;
	private JTextField typeInput;
	private JTextField sizeInput;
	
	private int fileOutputNumber = 0;
	
	private WillPangBallGen ballGen;
	
	public Options (WillPangBallGen ballGen) {

		this.ballGen = ballGen;

		setTitle("BallGen Options");
		setBounds(10, 10, 300, 300);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); //exit the application when this frame is closed
		setResizable(false); //don't let the user resize the frame
		
		// Create a new ImagePane
		panel  = new JPanel();
		
				//text boxes
		
//		panel.setLayout (new GridLayout(5,2));

		panel.add(new JLabel("          BALL OPTIONS          "));

		initialVelocityInput = new JTextField("0", 5);
		JTextField velHelp = new JTextField("Initial Velocity e.g. 10, -20");
		velHelp.setEditable(false);
		panel.add(velHelp);
		panel.add(initialVelocityInput);
		
		velHelp = new JTextField("Horisontal Direction e.g. -1, 0, 1.3");
		velHelp.setEditable(false);
		panel.add(velHelp);
		horDirectionInput = new JTextField("1", 5);
		panel.add(horDirectionInput);

		velHelp = new JTextField("Filename");
		velHelp.setEditable(false);
		panel.add(velHelp);
		fileInput = new JTextField("WillPang balls", 15);
		panel.add(fileInput);

		velHelp = new JTextField("Pixel Step Rate (cursor keys)");
		velHelp.setEditable(false);
		panel.add(velHelp);
		stepInput = new JTextField("10", 3);
		panel.add(stepInput);

		velHelp = new JTextField("Random Range ");
		velHelp.setEditable(false);
		panel.add(velHelp);
		ranInput1 = new JTextField("-15", 5);
		ranInput2 = new JTextField("15", 5);
		panel.add(ranInput1);
		panel.add(new JLabel("  to  "));
		panel.add(ranInput2);

		velHelp = new JTextField("Ball Type");
		velHelp.setEditable(false);
		panel.add(velHelp);
		typeInput = new JTextField("0", 5);
		panel.add(typeInput);

		velHelp = new JTextField("Ball Size");
		velHelp.setEditable(false);
		panel.add(velHelp);
		sizeInput = new JTextField("4", 5);
		panel.add(sizeInput);

		
		velHelp = new JTextField("Note: To change the size of a ball \nPress the keys 0-9.", 25);
		velHelp.setEditable(false);
		panel.add(velHelp);
		
		JButton button = new JButton ("Save");
		button.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent evt) {
				printAll();
			}
		});
		
		JButton count = new JButton ("Count Balls");
		count.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent evt) {
				countBalls();
			}
		});
		
		
		panel.add(button);
		panel.add(count);
		
		
		Container c = getContentPane();

		c.add(panel);
		setVisible(true); //show the frame
		
	}
	
	public void countBalls() {
		JOptionPane.showMessageDialog(null, ballGen.ballGenPanel.balls.count(0), "Ball Count", JOptionPane.INFORMATION_MESSAGE );
		
//		System.out.println();
	}
	
	public void printAll() {
		String filename = fileInput.getText();
		filename = filename + fileOutputNumber + ".wplb";
		
//		ballGen.ballGenPanel.balls.
		
		try {
			PrintWriter pw = new PrintWriter(new FileWriter(filename));

			pw.print(ballGen.ballGenPanel.balls.toString());
			pw.close();
		} catch (IOException e) {
			System.out.println("IO Error");
			JOptionPane.showMessageDialog(null, "There was an IO error writing to " + filename, "IO Error", JOptionPane.ERROR_MESSAGE );
		}
		
		
		System.out.println(ballGen.ballGenPanel.balls.toString());
		
		fileOutputNumber++;
	}
	
	public void run() {
		while (true) {
			Delegate.doze(2500);
			repaint();
		}
	}
	
	
	public int getInitialVelocity () {
		int vel;
		try {
			vel = Integer.parseInt(initialVelocityInput.getText());
		} catch (NumberFormatException e) {
			vel = 1;
		}
		
		return vel;
	}
	
	public double getHorDirection () {
		double dir;
		try {
			dir = Double.parseDouble(horDirectionInput.getText());
		} catch (NumberFormatException e) {
			dir = 1;
		}
		
		return dir;
	

	}
	
	public int getStepRate () {
		int step;
		try {
			step = Integer.parseInt(stepInput.getText());
		} catch (NumberFormatException e) {
			step = 1;
		}
		
		return step;
	

	}	
	
	public int getRan1 () {
		int ran;
		try {
			ran = Integer.parseInt(ranInput1.getText());
		} catch (NumberFormatException e) {
			ran = 1;
		}
		
		return ran;
	

	}	
	public int getRan2 () {
		int ran;
		try {
			ran = Integer.parseInt(ranInput2.getText());
		} catch (NumberFormatException e) {
			ran = 1;
		}
		
		return ran;
	

	}	
	public int getBallSize () {
		int ran;
		try {
			ran = Integer.parseInt(sizeInput.getText());
		} catch (NumberFormatException e) {
			ran = 4;
		}
		
		return ran;
	

	}	
	
	public int getType () {
		int ran;
		try {
			ran = Integer.parseInt(typeInput.getText());
		} catch (NumberFormatException e) {
			ran = 0;
		}
		
		return ran;
	

	}	
	public void setStepRate (int step) {
		stepInput.setText(step + "");
	}
	public void setSize (int size) {
		sizeInput.setText(size + "");
	}
	public void setType (int type) {
		typeInput.setText(type + "");
	}
	
	public void setHorDirection (int direction) {
		horDirectionInput.setText(direction + "");

	}
	public void setInitialVelocity (int velocity) {
		initialVelocityInput.setText(velocity + "");

	}
	

}